<?php
/**
 * Plugin Name: WooCommerce - Custom Users Meta Extra Search
 * Plugin URI: http://www.remicorson.com/custom-users-meta-search/
 * Description: Add WooCommerce users meta fields to user search in the WordPress administration
 * Version: 1.0
 * Author: Remi Corson
 * Author URI: http://remicorson.com
 * Requires at least: 3.5
 * Tested up to: 3.5
 *
 * Text Domain: -
 * Domain Path: -
 *
 */

/* ----------------------------------------
* Make WooCommerce users custom meta fields available in users search
----------------------------------------- */

if(is_admin()) {

   // the actual improvement of the query
    function woo_user_extra_search($wp_user_query) {
    
    	global $wpdb;
    	
        if(false === strpos($wp_user_query -> query_where, '@') && !empty($_GET["s"])) {

            $fields_id = array();

			// Get the WooCommerce custom users meta fields
			$fields_meta = 'billing_first_name,billing_last_name,billing_company,billing_email,shipping_first_name,shipping_last_name,shipping_company';

			$field_key = array_map('trim', explode(",",$fields_meta));

			$add = "";

			if(!empty($field_key)) {
				$add = " OR meta_key='".implode("' OR meta_key='",$field_key)."'";
			}

            $usermeta_affected_ids = $wpdb -> get_results("SELECT DISTINCT user_id FROM " . $wpdb -> prefix . "usermeta WHERE (meta_key='first_name' OR meta_key='last_name'".$add.") AND meta_value LIKE '%" . mysql_real_escape_string($_GET["s"]) . "%'");
           
            foreach($usermeta_affected_ids as $maf) {
                array_push($fields_id,$maf->user_id);
            }

            $users_affected_ids = $wpdb -> get_results("SELECT DISTINCT ID FROM " . $wpdb -> prefix . "users WHERE user_nicename LIKE '%" . mysql_real_escape_string($_GET["s"]) . "%' OR user_email LIKE '%" . mysql_real_escape_string($_GET["s"]) . "%'");

            foreach($users_affected_ids as $maf) {
                if(!in_array($maf->ID,$fields_id)) {
                    array_push($fields_id,$maf->ID);
                }
            }

            $id_string = implode(",",$fields_id);

            $wp_user_query -> query_where = str_replace("user_nicename LIKE '%" . mysql_real_escape_string($_GET["s"]) . "%'", "ID IN(" . $id_string . ")", $wp_user_query -> query_where);
        }
        return $wp_user_query;
	        

    }

	// add the overwrite actions for the search
    add_action('pre_user_query', 'woo_user_extra_search');

}
